﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq.Mapping;
using System.Data.Linq;
using System.Data.SqlClient;

namespace AssociationOneToOne
{
    [Table]
    class Adres
    {
        private EntityRef<Osoba> OsobaStorage;

        [Column( IsPrimaryKey=true, CanBeNull=false )]
        public int ID { get; set; }
        [Column]
        public string Miasto { get; set; }
        [Column]
        public string Ulica { get; set; }
        [Column]
        private int? Osoba_ID { get; set; }
        [Association( Storage="OsobaStorage", ThisKey="Osoba_ID", IsForeignKey=true )]
        public Osoba Osoba
        {
            get { return this.OsobaStorage.Entity; }
            set { this.OsobaStorage.Entity = value; }
        }
    }
    [Table]
    class Osoba
    {
        private EntityRef<Adres> AdresStorage;

        [Column( IsPrimaryKey=true, CanBeNull=false )]
        public int ID { get; set; }
        [Column]
        public string Imie { get; set; }
        [Column]
        public string Nazwisko { get; set; }
        [Column]
        private int? Adres_ID { get; set; }
        [Association( Storage="AdresStorage", ThisKey="Adres_ID", IsForeignKey=true )]
        public Adres Adres
        {
            get { return this.AdresStorage.Entity; }
            set { this.AdresStorage.Entity = value; }
        }
    }

    class Program
    {
        static void Main( string[] args )
        {
            DataContext dc = new DataContext( new SqlConnection( "Data Source=.;Initial Catalog=Test;Integrated Security=True" ) );
            var adresy = dc.GetTable<Adres>();
            var osoby = dc.GetTable<Osoba>();

            var o1 = new Osoba { ID = 1, Imie = "J01", Nazwisko = "K01" };
            var o2 = new Osoba { ID = 2, Imie = "J02", Nazwisko = "K02" };
            var o3 = new Osoba { ID = 3, Imie = "J03", Nazwisko = "K03" };

            var a1 = new Adres { ID = 1, Miasto = "W1", Ulica = "A" };
            var a2 = new Adres { ID = 2, Miasto = "W2", Ulica = "B" };
            var a3 = new Adres { ID = 3, Miasto = "W3", Ulica = "C" };

            adresy.InsertOnSubmit( a1 );
            adresy.InsertOnSubmit( a2 );
            adresy.InsertOnSubmit( a3 );
            osoby.InsertOnSubmit( o1 );
            osoby.InsertOnSubmit( o2 );
            osoby.InsertOnSubmit( o3 );
            dc.SubmitChanges();
            o1.Adres = a1; o2.Adres = a2; o3.Adres = a3;
            a1.Osoba = o1; a2.Osoba = o2; a3.Osoba = o3;
            dc.SubmitChanges();

            Console.WriteLine( adresy.Count() );
            Console.WriteLine( osoby.Count() );

            foreach ( var o in osoby )
                Console.WriteLine( o.Nazwisko );

            Console.WriteLine( osoby.First().Adres.Miasto );
        }
    }
}
