﻿/*
 
create table Osoba
(
	ID int primary key,
	Imie varchar(100),
	Nazwisko varchar(200),
	Pensja int,
	Wychowawca int,
	TypOsoby int
)

*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq.Mapping;
using System.Data.Linq;
using System.Data.SqlClient;

namespace Inheritance
{
    [Table]
    [InheritanceMapping( Code=1, Type=typeof( Osoba ), IsDefault=true )]
    [InheritanceMapping( Code=2, Type=typeof( Pracownik ) )]
    [InheritanceMapping( Code=3, Type=typeof( Nauczyciel ) )]
    class Osoba
    {
        [Column( IsPrimaryKey=true, CanBeNull=false )]
        public int ID { get; set; }
        [Column( IsDiscriminator=true )]
        private int TypOsoby { get; set; }
        [Column]
        public string Imie { get; set; }
        [Column]
        public string Nazwisko { get; set; }
    }

    class Pracownik : Osoba
    {
        [Column]
        public int Pensja { get; set; }
    }

    class Nauczyciel : Pracownik
    {
        [Column]
        public int Wychowawca { get; set; }
    }

    class Program
    {
        static void Main( string[] args )
        {
            DataContext dc = new DataContext( new SqlConnection( "Data Source=.;Initial Catalog=Test;Integrated Security=True" ) );
            var osoby = dc.GetTable<Osoba>();

            var o = new Osoba { ID = 1, Imie = "A", Nazwisko = "B" };
            var p = new Pracownik { ID = 2, Imie = "J", Nazwisko = "K", Pensja = 1234 };
            var n = new Nauczyciel { ID = 3, Imie = "D", Nazwisko = "Z", Pensja = 222, Wychowawca = 7 };
            osoby.InsertOnSubmit( o );
            osoby.InsertOnSubmit( p );
            osoby.InsertOnSubmit( n );
            dc.SubmitChanges();

            var query = from x in dc.GetTable<Osoba>().OfType<Pracownik>()
                        select x;

            foreach ( var y in query )
            {
                Console.WriteLine( y.Nazwisko );
            }
        }
    }
}
