﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;

namespace LazyLoading
{
    class Program
    {
        static void Main(string[] args)
        {
            // 1. Domyślnie wszystko jest leniwie dociągane

            Test ctx = new Test("Data Source=.;Initial Catalog=Test;Integrated Security=True");

            //ctx.DeferredLoadingEnabled = false; // określa, czy dociągać brakujące obiekty; domyślnie true

            foreach (var o in ctx.Osoba)
                Console.WriteLine("{0} {1} {2}", o.Imie, o.Nazwisko, o.Jednostka.Nazwa);

            foreach (var j in ctx.Jednostka)
                Console.WriteLine("{0}", j.Nazwa, j.Osoba.First().Nazwisko);


            // 2. Gorliwość wybiórcza: robiony jest JOIN (property LoadWith)
            Test ctx2 = new Test("Data Source=.;Initial Catalog=Test;Integrated Security=True");

            DataLoadOptions lo = new DataLoadOptions();
            //lo.LoadWith<Osoba>(o => o.Jednostka);
            lo.LoadWith<Jednostka>(j => j.Osoba);

            ctx2.LoadOptions = lo;

            foreach (var o in ctx2.Osoba)
                Console.WriteLine("{0} {1} {2}", o.Imie, o.Nazwisko, o.Jednostka.Nazwa);

            foreach (var j in ctx2.Jednostka)
                Console.WriteLine("{0}", j.Nazwa, j.Osoba.First().Nazwisko);


            // 3. Gorliwość wybiórcza z warunkami: robiony jest JOIN (property AssociateWith)
            Test ctx3 = new Test("Data Source=.;Initial Catalog=Test;Integrated Security=True");

            DataLoadOptions lo2 = new DataLoadOptions();
            lo2.AssociateWith<Jednostka>(j => j.Osoba.Where( o => o.Nazwisko == "Kowalski04" ) );

            ctx3.LoadOptions = lo2;

            foreach (var j in ctx3.Jednostka )
                Console.WriteLine("{0} {1}", j.Nazwa, j.Osoba.Count() );


        }
    }
}
