﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq.Mapping;
using System.IO;

namespace SimpleExample
{
    class Program
    {
        static void Main( string[] args )
        {
            using ( DataClassesDataContext dc = new DataClassesDataContext( "Data Source=.;Initial Catalog=Test;Integrated Security=True" ) )
            {
                var res = ( from o in dc.Osobas select o ).Skip( 2 ).Take( 2 );
                foreach ( var o in res )
                    Console.WriteLine( o.Nazwisko );

                var os = res.First();
                os.Nazwisko += "X";
                dc.Osobas.DeleteOnSubmit( dc.Osobas.First() );
                dc.Osobas.InsertOnSubmit( new Osoba { ID = 100, Imie = "J", Nazwisko = "K" } );
                dc.SubmitChanges();
            }

            byte[] map = File.ReadAllBytes( "Model\\TestMapping.xml" );
            MemoryStream ms = new MemoryStream( map );
            using ( Test dc = new Test( "Data Source=.;Initial Catalog=Test;Integrated Security=True", System.Data.Linq.Mapping.XmlMappingSource.FromStream( ms ) ) )
            {
                var res = ( from o in dc.Osoba select o ).Skip( 2 ).Take( 2 );
                foreach ( var o in res )
                    Console.WriteLine( o.Nazwisko );

                var os = res.First();
                os.Nazwisko += "X";
                dc.Osoba.DeleteOnSubmit( dc.Osoba.First() );
                dc.Osoba.InsertOnSubmit( new global::Osoba { ID = 101, Imie = "J", Nazwisko = "K" } );
                dc.SubmitChanges();
            }
        }
    }
}
